package javax.portlet;

public class PortletMode {

  public static final PortletMode VIEW = new PortletMode("view");
  public static final PortletMode EDIT = new PortletMode("edit");
  public static final PortletMode HELP = new PortletMode("help");
  private String name;

  public PortletMode(String name) {
    if (name == null) {
      throw new IllegalArgumentException("PortletMode name can not be NULL");
    } else {
      this.name = name.toLowerCase();
      return;
    }
  }

  public String toString() {
    return name;
  }

  public int hashCode() {
    return name.hashCode();
  }

  public boolean equals(Object object) {
    if (object instanceof PortletMode) {
      return name.equals(((PortletMode)object).name);
    } else {
      return false;
    }
  }

}
