package javax.portlet;

import java.io.*;
import java.util.Locale;
import javax.servlet.http.Cookie;

public interface RenderResponse extends PortletResponse {

  public static final String EXPIRATION_CACHE = "portlet.expiration-cache";
  public static final String CACHE_SCOPE = "portlet.cache-scope";
  public static final String PUBLIC_SCOPE = "portlet.public-scope";
  public static final String PRIVATE_SCOPE = "portlet.private-scope";
  public static final String ETAG = "portlet.ETag";
  public static final String USE_CACHED_CONTENT = "portlet.use-cached-content";

  public abstract String getContentType();

  public abstract void setTitle(String s);

  public abstract void setContentType(String s);

  public abstract String getCharacterEncoding();

  public abstract PrintWriter getWriter() throws IOException;

  public abstract Locale getLocale();

  public abstract void setBufferSize(int i);

  public abstract int getBufferSize();

  public abstract void flushBuffer() throws IOException;

  public abstract void resetBuffer();

  public abstract boolean isCommitted();

  public abstract void reset();

  public abstract OutputStream getPortletOutputStream() throws IOException;

    /**
     * Returns the cache control object allowing to set
     * specific cache settings valid for the markup
     * returned in this response.
     */
  public abstract CacheControl getCacheControl();
  
  public abstract void addProperty(Cookie cookie);
}
