package javax.portlet;

import java.io.IOException;
import java.util.Locale;
import java.lang.String;
import java.io.OutputStream;
import java.io.PrintWriter;
import javax.servlet.http.Cookie;


public interface ResourceResponse extends PortletResponse {
  
  public static final String EXPIRATION_CACHE = "portlet.expiration-cache";
  public static final String CACHE_SCOPE = "portlet.cache-scope";
  public static final String PUBLIC_SCOPE = "portlet.public-scope";
  public static final String PRIVATE_SCOPE = "portlet.private-scope";
  public static final String ETAG = "portlet.ETag";
  public static final String USE_CACHED_CONTENT = "portlet.use-cached-content";
  
  public String getContentType();
  public void setTitle(String title);
  public void setContentType(String type);
  public String getCharacterEncoding();
  public PrintWriter getWriter() throws IOException;
  public Locale getLocale();
  public void setBufferSize(int size);
  public int getBufferSize();
  public void flushBuffer() throws IOException;
  public void resetBuffer();
  public boolean isCommitted();
  public void reset();
  public OutputStream getPortletOutputStream() throws IOException;
  public CacheControl getCacheControl();
  public void addProperty(Cookie cookie);
  public void setLocale(Locale loc);
  public void setCharacterEncoding(String charset);

  
}
