/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

/**
 * Created by The eXo Platform SARL
 * Author : Roman Pedchenko <roman.pedchenko@exoplatform.com.ua>
 */

package org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp;


import javax.portlet.ClientHttpRequest;
//import javax.servlet.http.HttpServletRequest;
//import org.exoplatform.Constants;
//import org.exoplatform.container.ExoContainer;

public abstract class ClientHttpRequestImp extends PortletRequestImp implements ClientHttpRequest {

  private boolean isCallGetReader;

  public ClientHttpRequestImp(RequestContext reqCtx) {
    super(reqCtx);
    isCallGetReader = false;
//    enc = super.getCharacterEncoding();
  }

  public java.io.InputStream getPortletInputStream() throws java.io.IOException {
    if (this.isCallGetReader) {
      throw new IllegalStateException("This method cannot be called, when getReader() method has been called");
    }
    String contentType = getHeader("content-type");
    if ("application/x-www-form-urlencoded".equals(contentType)) {
      throw new IllegalStateException("content type cannot be application/x-www-form-urlencoded");
    }
    return super.getInputStream();
  }

  public void setCharacterEncoding(String enc) throws java.io.UnsupportedEncodingException {
    if (this.isCallGetReader) {
      throw new IllegalStateException("This method cannot be called, when getReader() method has been called");
    }
    super.setCharacterEncoding(enc);
    this.enc = enc;
    this.encodingModified = true;
  }

  public java.io.BufferedReader getReader()
      throws java.io.UnsupportedEncodingException, java.io.IOException {
    String contentType = getHeader("content-type");
    if ("application/x-www-form-urlencoded".equals(contentType)) {
      throw new IllegalStateException("content type cannot be application/x-www-form-urlencoded");
    }
    this.isCallGetReader = true;
    return super.getReader();
  }

  public String getCharacterEncoding() {
    return super.getCharacterEncoding();
  }
  
  public String getContentType() {
    return super.getContentType();
  }
  
  public int getContentLength() {
    return super.getContentLength();
  }
  
  public String getMethod() {
    return super.getMethod();
  }
  
  public abstract String getLifecyclePhase();
  
}
